#!/bin/sh

JAR=~anders/anna-20120702.jar
TRAIN=ALL/eng_train_v4_c09aug.c09
DEV=ALL/eng_dev_v4_c09aug.c09

#COUNT="-count 2000"
#for i in `seq 0 9`; do
#    java -cp $JAR is2.lemmatizer.Lemmatizer $LEMMA_UC -train split/p-${i} -test split/r-${i} -model split/l-${i}.mdl -out split/l-${i} -eval split/r-${i} $COUNT &> split/l-${i}.log &
#done

#java -cp $JAR is2.lemmatizer.Lemmatizer $LEMMA_UC -train $TRAIN -test $DEV -model all_lemma.mdl -out ${DEV}.l -eval $DEV $COUNT &> all_lemma.log &

#echo "Waiting for lemmatizer jobs to finish..."
#wait
#echo "Done waiting!"
#sync

#exit 0;

echo "Preparing tagger training data"

#echo -n "" > ${TRAIN}.l
#for i in `seq 0 9`; do
#    echo -n "" > split/tagtrain-${i}
#    cat split/l-${i} >> ${TRAIN}.l
#    for j in `seq 0 9`; do
#	if [ $i -ne $j ]; then
#	    echo "$j -> $i"
#	    cat split/l-${j} >> split/tagtrain-${i}
#	fi
#    done
#done

#sync

echo "Training tagger"

for i in `seq 0 9`; do
    java -cp $JAR is2.tag.Tagger -train split/p-${i} -test split/r-${i} -model split/t-${i}.mdl -out split/t-${i} -eval split/r-${i} $COUNT &> split/t-${i}.log &
done

java -cp $JAR is2.tag.Tagger -train ${TRAIN} -test ${DEV} -model all_tag.mdl -out ${DEV}.t -eval ${DEV} $COUNT &> all_t_tag.log &

echo "Waiting for jobs to finish..."
wait
echo "Done."

sync

echo "Preparing parser training data"

echo -n "" > ${TRAIN}.t
for i in `seq 0 9`; do
    echo -n "" > split/parsetrain-t-${i}
    cat split/t-${i} >> ${TRAIN}.t
    for j in `seq 0 9`; do
	if [ $i -ne $j ]; then
	    cat split/t-${j} >> split/parsetrain-t-${i}
	fi
    done
done

sync

for i in `seq 0 5`; do
    java -cp $JAR is2.parser.Parser -train split/parsetrain-t-${i} -test split/t-${i} -model split/prs-t-${i}.mdl -out split/prs-t-${i} -eval split/r-${i} -cores 2 $COUNT &> split/prs-t-${i}.log &
done

echo "Training first batch of parsers, waiting..."
wait
echo "Done"


for i in `seq 6 9`; do
    java -cp $JAR is2.parser.Parser -train split/parsetrain-t-${i} -test split/t-${i} -model split/prs-t-${i}.mdl -out split/prs-t-${i} -eval split/r-${i} -cores 2 $COUNT &> split/prs-t-${i}.log &
done

java -cp $JAR is2.parser.Parser -train ${TRAIN}.t -test ${DEV}.t -model all_t_parse.mdl -out ${DEV}.tp -eval ${DEV} -cores 3 $COUNT &> all_t_parse.log &

echo "Training second batch of parsers, waiting..."
wait
echo "Done"

echo "Concatenating train data"
echo -n "" > ${TRAIN}.tp
for i in `seq 0 9`; do
    cat split/prs-t-${i} >> ${TRAIN}.tp
done
