#!/usr/bin/perl

use strict;
use warnings;
use open ':encoding(utf8)'; #Equivalent to perl -CD,
binmode STDERR,":encoding(utf8)";
binmode STDOUT,":encoding(utf8)"; #Equivalent to -CS
binmode STDIN,":encoding(utf8)";

use unstrip; #This module needs to be in the same dir

my $conll=shift;
my $strip_prefix=shift;
my $split_count=(scalar(@ARGV)?shift:10);

open CONLL,$conll or die("Failed to open $conll");
my @stripFHs;
for(my $i=0;$i<$split_count;++$i){
    my $in=$strip_prefix . $i;
    open $stripFHs[$i],$in or die("Failed ot open $in");
}

my $senCount=0;
my $splitIdx=-1;
my $lastDocName="<dummy>";

while(<CONLL>){
    chomp;
    if($_=~/^#begin document \(([^)]+)\)/){
	print $_,"\n";
	my $docName=$1;
	if($docName ne $lastDocName){
	    $splitIdx++;
	    $splitIdx%=$split_count;
	    $lastDocName=$docName;
	}
	next;
    } elsif($_=~/^#end document/){
	print $_,"\n";
	next;
    } elsif($_=~/^#/){
	die("Failed to parse line: $_");
    }
    my $sl=readline $stripFHs[$splitIdx];
    chomp $sl;
    if($_=~/^\s*$/){
	$senCount++;
	print "\n";
	next;
    }
    my $outLine=unstrip::joinLine($_,$sl);
    print $outLine;
}

for(my $i=0;$i<$split_count;++$i){
    close $stripFHs[$i];
}

close CONLL;
