#!/usr/bin/perl

use strict;
use warnings;
use open ':encoding(utf8)'; #Equivalent to perl -CD,
binmode STDERR,":encoding(utf8)";
binmode STDOUT,":encoding(utf8)"; #Equivalent to -CS
binmode STDIN,":encoding(utf8)";

my $SPLITS=10;
my $splitDir="split/";

`mkdir -v $splitDir`;

my @fhP; #P is the training part
my @fhR; #R is the testing part
for(my $i=0;$i<$SPLITS;++$i){
    open($fhP[$i],">",$splitDir."p-$i") or die("$!");
    open($fhR[$i],">",$splitDir."r-$i") or die("$!");
}

my $docCount=-1;
my $partCount=-1;
my $lastDocName="<none>";
my $tInd=-1;
while(<>){
    chomp;
    if($_=~/^#/){
	if($_=~/^#begin document \(([^\)]+)\); part \d+/){
	    $partCount++;
	    if($1 ne $lastDocName){
		$docCount++;
		$lastDocName=$1;
		$tInd=$docCount%$SPLITS;
	    }
	    print STDERR "$_ \t $tInd\n";
	    next;
	} elsif($_=~/^#end document/){
#	    $docCount++;
#	    $tInd=$docCount%$SPLITS;
	    next;
	} else {
	    die("Failed to parse line: $_");
	}
    }
    for(my $j=0;$j<$SPLITS;++$j){
	my $fh=($j==$tInd?$fhR[$j]:$fhP[$j]);
	select $fh;
	my $out;
	if($_=~/^\s*$/){
	    $out="";
	} else {
	    my @cols=split(/\t/);
	    $out=join("\t",@cols[0..12]);
	}
	print $out,"\n";
    }
}


for(my $i=0;$i<$SPLITS;++$i){
    close $fhP[$i];
    close $fhR[$i];
}

print STDERR "\nProcessed $docCount documents ($partCount parts)\n";
