package ims.coref.data;

import java.util.Map;

public class PairInstance {

	public static final boolean USE_FEATURE_CACHING=false;
	
	public final Span ant;
	public final Span ana;
	
	public final boolean corefers;
	
	
	private DTPath dtPath;
	public final int mentionDist;
	public final int nesBetween;
//	public final int entitiesBetween
	
	private Map<String,String> featureCache=null; //=new HashMap<String,String>(); 
	
	public PairInstance(Span ant,Span ana,int mentionDist,int nesBetween){
		this(ant,ana,false,mentionDist,nesBetween);
	}
	
	public PairInstance(Span ant,Span ana,boolean corefers,int mentionDist,int nesBetween){
		this.ant=ant;
		this.ana=ana;
		this.corefers=corefers;
		this.mentionDist=mentionDist;
		this.nesBetween=nesBetween;
	}

	
	public DTPath getDTPath(){
		if(dtPath==null)
			this.dtPath=new DTPath(ant,ana);
		return dtPath;
	}
	
	public String toString(){
		StringBuilder sb=new StringBuilder();
		sb.append("ant: ").append(ant.s.sentenceIndex).append(",").append(ant.start).append(",").append(ant.end).append("  ");
		sb.append("ana: ").append(ana.s.sentenceIndex).append(",").append(ana.start).append(",").append(ana.end);
		return sb.toString();
	}
	
	public String getCachedFeature(String key){
		return featureCache.get(key);
	}
	public void addToCache(String key,String value){
		featureCache.put(key, value);
	}

}
