package ims.coref.features;

import ims.coref.data.Document;
import ims.coref.data.PairInstance;
import ims.coref.data.Span;
import ims.coref.features.extractors.SpanToken;
import ims.coref.features.extractors.SpanTokenExtractor;
import ims.coref.features.extractors.TargetSpan;
import ims.coref.features.extractors.TargetSpanExtractor;
import ims.coref.features.extractors.TokenTrait;
import ims.coref.features.extractors.TokenTraitExtractor;

public class F_DepSubCat extends AbstractSingleDataDrivenFeature {
	private static final long serialVersionUID = 3972676743207680367L;

	private final TargetSpanExtractor tse;
	private final SpanTokenExtractor ste;
	private final TokenTraitExtractor tte;
	
	
	public F_DepSubCat(TargetSpan ts, SpanToken st, TokenTrait tt, int cutOff) {
		super(ts.toString()+st.toString()+(tt==TokenTrait.Fun?"Dep":tt.toString())+"SubCat",cutOff);
		this.tse=new TargetSpanExtractor(ts);
		this.ste=new SpanTokenExtractor(st);
		this.tte=new TokenTraitExtractor(tt);
	}

	@Override
	public String extractStringValue(PairInstance instance, Document d) {
		Span sp=tse.getSpan(instance);
		int parent=ste.getToken(sp);
		StringBuilder sb=new StringBuilder();
		for(int i=1;i<sp.s.forms.length;++i){
			if(sp.s.dt.heads[i]==parent){
				sb.append(tte.getTrait(sp.s, i)).append(" + ");
			}
		}
		return sb.toString();
	}

}
